/* Copyright (c) 2006, NIF File Format Library and Tools
All rights reserved.  Please see niflib.h for license. */

//-----------------------------------NOTICE----------------------------------//
// Some of this file is automatically filled in by a Python script.  Only    //
// add custom code in the designated areas or it will be overwritten during  //
// the next update.                                                          //
//-----------------------------------NOTICE----------------------------------//

//--BEGIN FILE HEAD CUSTOM CODE--//
//--END CUSTOM CODE--//

#include "../../include/FixLink.h"
#include "../../include/ObjectRegistry.h"
#include "../../include/NIF_IO.h"
#include "../../include/obj/bhkRigidBody.h"
#include "../../include/gen/QuaternionXYZW.h"
#include "../../include/gen/InertiaMatrix.h"
#include "../../include/obj/bhkConstraint.h"
using namespace Niflib;

//Definition of TYPE constant
const Type bhkRigidBody::TYPE("bhkRigidBody", &bhkEntity::TYPE );

bhkRigidBody::bhkRigidBody() : unknownInt1((int)0), unknownInt2((int)0x7c37a201), collisionResponse_((hkResponseType)1), unknownByte((byte)0xbe), processContactCallbackDelay_((unsigned short)0xffff), unknown2Shorts(2,(unsigned short)35899,(unsigned short)16336), layerCopy((OblivionLayer)1), colFilterCopy((byte)0), unknown7Shorts(7,(unsigned short)0,(unsigned short)21280,(unsigned short)2481,(unsigned short)62977,(unsigned short)65535,(unsigned short)44,(unsigned short)0), mass(1.0f), linearDamping(0.0f), angularDamping(0.05f), friction(0.5f), restitution(0.4f), maxLinearVelocity(200.0f), maxAngularVelocity(200.0f), penetrationDepth(0.15f), motionSystem((MotionSystem)1), deactivatorType((DeactivatorType)1), solverDeactivation((SolverDeactivation)1), qualityType((MotionQuality)0), autoRemoveLevel((unsigned int)0), userDatasInContactPointProperties_((unsigned int)0), forceCollideOntoPpu_((unsigned int)0), numConstraints((unsigned int)0), unknownInt9((unsigned int)0) {
	//--BEGIN CONSTRUCTOR CUSTOM CODE--//
	//--END CUSTOM CODE--//
}

bhkRigidBody::~bhkRigidBody() {
	//--BEGIN DESTRUCTOR CUSTOM CODE--//
	//--END CUSTOM CODE--//
}

const Type & bhkRigidBody::GetType() const {
	return TYPE;
}

NiObject * bhkRigidBody::Create() {
	return new bhkRigidBody;
}

void bhkRigidBody::Read( istream& in, list<unsigned int> & link_stack, const NifInfo & info ) {
	//--BEGIN PRE-READ CUSTOM CODE--//
	//--END CUSTOM CODE--//

	unsigned int block_num;
	bhkEntity::Read( in, link_stack, info );
	NifStream( unknownInt1, in, info );
	NifStream( unknownInt2, in, info );
	for (unsigned int i1 = 0; i1 < 3; i1++) {
		NifStream( unknown3Ints[i1], in, info );
	};
	NifStream( collisionResponse_, in, info );
	NifStream( unknownByte, in, info );
	NifStream( processContactCallbackDelay_, in, info );
	for (unsigned int i1 = 0; i1 < 2; i1++) {
		NifStream( unknown2Shorts[i1], in, info );
	};
	NifStream( layerCopy, in, info );
	NifStream( colFilterCopy, in, info );
	for (unsigned int i1 = 0; i1 < 7; i1++) {
		NifStream( unknown7Shorts[i1], in, info );
	};
	NifStream( translation, in, info );
	NifStream( rotation.x, in, info );
	NifStream( rotation.y, in, info );
	NifStream( rotation.z, in, info );
	NifStream( rotation.w, in, info );
	NifStream( linearVelocity, in, info );
	NifStream( angularVelocity, in, info );
	NifStream( inertia.m11, in, info );
	NifStream( inertia.m12, in, info );
	NifStream( inertia.m13, in, info );
	NifStream( inertia.m14, in, info );
	NifStream( inertia.m21, in, info );
	NifStream( inertia.m22, in, info );
	NifStream( inertia.m23, in, info );
	NifStream( inertia.m24, in, info );
	NifStream( inertia.m31, in, info );
	NifStream( inertia.m32, in, info );
	NifStream( inertia.m33, in, info );
	NifStream( inertia.m34, in, info );
	NifStream( center, in, info );
	NifStream( mass, in, info );
	NifStream( linearDamping, in, info );
	NifStream( angularDamping, in, info );
	NifStream( friction, in, info );
	NifStream( restitution, in, info );
	NifStream( maxLinearVelocity, in, info );
	NifStream( maxAngularVelocity, in, info );
	NifStream( penetrationDepth, in, info );
	NifStream( motionSystem, in, info );
	NifStream( deactivatorType, in, info );
	NifStream( solverDeactivation, in, info );
	NifStream( qualityType, in, info );
	NifStream( autoRemoveLevel, in, info );
	NifStream( userDatasInContactPointProperties_, in, info );
	NifStream( forceCollideOntoPpu_, in, info );
	NifStream( numConstraints, in, info );
	constraints.resize(numConstraints);
	for (unsigned int i1 = 0; i1 < constraints.size(); i1++) {
		NifStream( block_num, in, info );
		link_stack.push_back( block_num );
	};
	NifStream( unknownInt9, in, info );

	//--BEGIN POST-READ CUSTOM CODE--//
	//--END CUSTOM CODE--//
}

void bhkRigidBody::Write( ostream& out, const map<NiObjectRef,unsigned int> & link_map, const NifInfo & info ) const {
	//--BEGIN PRE-WRITE CUSTOM CODE--//
	//--END CUSTOM CODE--//

	bhkEntity::Write( out, link_map, info );
	numConstraints = (unsigned int)(constraints.size());
	NifStream( unknownInt1, out, info );
	NifStream( unknownInt2, out, info );
	for (unsigned int i1 = 0; i1 < 3; i1++) {
		NifStream( unknown3Ints[i1], out, info );
	};
	NifStream( collisionResponse_, out, info );
	NifStream( unknownByte, out, info );
	NifStream( processContactCallbackDelay_, out, info );
	for (unsigned int i1 = 0; i1 < 2; i1++) {
		NifStream( unknown2Shorts[i1], out, info );
	};
	NifStream( layerCopy, out, info );
	NifStream( colFilterCopy, out, info );
	for (unsigned int i1 = 0; i1 < 7; i1++) {
		NifStream( unknown7Shorts[i1], out, info );
	};
	NifStream( translation, out, info );
	NifStream( rotation.x, out, info );
	NifStream( rotation.y, out, info );
	NifStream( rotation.z, out, info );
	NifStream( rotation.w, out, info );
	NifStream( linearVelocity, out, info );
	NifStream( angularVelocity, out, info );
	NifStream( inertia.m11, out, info );
	NifStream( inertia.m12, out, info );
	NifStream( inertia.m13, out, info );
	NifStream( inertia.m14, out, info );
	NifStream( inertia.m21, out, info );
	NifStream( inertia.m22, out, info );
	NifStream( inertia.m23, out, info );
	NifStream( inertia.m24, out, info );
	NifStream( inertia.m31, out, info );
	NifStream( inertia.m32, out, info );
	NifStream( inertia.m33, out, info );
	NifStream( inertia.m34, out, info );
	NifStream( center, out, info );
	NifStream( mass, out, info );
	NifStream( linearDamping, out, info );
	NifStream( angularDamping, out, info );
	NifStream( friction, out, info );
	NifStream( restitution, out, info );
	NifStream( maxLinearVelocity, out, info );
	NifStream( maxAngularVelocity, out, info );
	NifStream( penetrationDepth, out, info );
	NifStream( motionSystem, out, info );
	NifStream( deactivatorType, out, info );
	NifStream( solverDeactivation, out, info );
	NifStream( qualityType, out, info );
	NifStream( autoRemoveLevel, out, info );
	NifStream( userDatasInContactPointProperties_, out, info );
	NifStream( forceCollideOntoPpu_, out, info );
	NifStream( numConstraints, out, info );
	for (unsigned int i1 = 0; i1 < constraints.size(); i1++) {
		if ( info.version < VER_3_3_0_13 ) {
			NifStream( (unsigned int)&(*constraints[i1]), out, info );
		} else {
			if ( constraints[i1] != NULL ) {
				NifStream( link_map.find( StaticCast<NiObject>(constraints[i1]) )->second, out, info );
			} else {
				NifStream( 0xFFFFFFFF, out, info );
			}
		}
	};
	NifStream( unknownInt9, out, info );

	//--BEGIN POST-WRITE CUSTOM CODE--//
	//--END CUSTOM CODE--//
}

std::string bhkRigidBody::asString( bool verbose ) const {
	//--BEGIN PRE-STRING CUSTOM CODE--//
	//--END CUSTOM CODE--//

	stringstream out;
	unsigned int array_output_count = 0;
	out << bhkEntity::asString();
	numConstraints = (unsigned int)(constraints.size());
	out << "  Unknown Int 1:  " << unknownInt1 << endl;
	out << "  Unknown Int 2:  " << unknownInt2 << endl;
	array_output_count = 0;
	for (unsigned int i1 = 0; i1 < 3; i1++) {
		if ( !verbose && ( array_output_count > MAXARRAYDUMP ) ) {
			out << "<Data Truncated. Use verbose mode to see complete listing.>" << endl;
			break;
		};
		if ( !verbose && ( array_output_count > MAXARRAYDUMP ) ) {
			break;
		};
		out << "    Unknown 3 Ints[" << i1 << "]:  " << unknown3Ints[i1] << endl;
		array_output_count++;
	};
	out << "  Collision Response?:  " << collisionResponse_ << endl;
	out << "  Unknown Byte:  " << unknownByte << endl;
	out << "  Process Contact Callback Delay?:  " << processContactCallbackDelay_ << endl;
	array_output_count = 0;
	for (unsigned int i1 = 0; i1 < 2; i1++) {
		if ( !verbose && ( array_output_count > MAXARRAYDUMP ) ) {
			out << "<Data Truncated. Use verbose mode to see complete listing.>" << endl;
			break;
		};
		if ( !verbose && ( array_output_count > MAXARRAYDUMP ) ) {
			break;
		};
		out << "    Unknown 2 Shorts[" << i1 << "]:  " << unknown2Shorts[i1] << endl;
		array_output_count++;
	};
	out << "  Layer Copy:  " << layerCopy << endl;
	out << "  Col Filter Copy:  " << colFilterCopy << endl;
	array_output_count = 0;
	for (unsigned int i1 = 0; i1 < 7; i1++) {
		if ( !verbose && ( array_output_count > MAXARRAYDUMP ) ) {
			out << "<Data Truncated. Use verbose mode to see complete listing.>" << endl;
			break;
		};
		if ( !verbose && ( array_output_count > MAXARRAYDUMP ) ) {
			break;
		};
		out << "    Unknown 7 Shorts[" << i1 << "]:  " << unknown7Shorts[i1] << endl;
		array_output_count++;
	};
	out << "  Translation:  " << translation << endl;
	out << "  x:  " << rotation.x << endl;
	out << "  y:  " << rotation.y << endl;
	out << "  z:  " << rotation.z << endl;
	out << "  w:  " << rotation.w << endl;
	out << "  Linear Velocity:  " << linearVelocity << endl;
	out << "  Angular Velocity:  " << angularVelocity << endl;
	out << "  m11:  " << inertia.m11 << endl;
	out << "  m12:  " << inertia.m12 << endl;
	out << "  m13:  " << inertia.m13 << endl;
	out << "  m14:  " << inertia.m14 << endl;
	out << "  m21:  " << inertia.m21 << endl;
	out << "  m22:  " << inertia.m22 << endl;
	out << "  m23:  " << inertia.m23 << endl;
	out << "  m24:  " << inertia.m24 << endl;
	out << "  m31:  " << inertia.m31 << endl;
	out << "  m32:  " << inertia.m32 << endl;
	out << "  m33:  " << inertia.m33 << endl;
	out << "  m34:  " << inertia.m34 << endl;
	out << "  Center:  " << center << endl;
	out << "  Mass:  " << mass << endl;
	out << "  Linear Damping:  " << linearDamping << endl;
	out << "  Angular Damping:  " << angularDamping << endl;
	out << "  Friction:  " << friction << endl;
	out << "  Restitution:  " << restitution << endl;
	out << "  Max Linear Velocity:  " << maxLinearVelocity << endl;
	out << "  Max Angular Velocity:  " << maxAngularVelocity << endl;
	out << "  Penetration Depth:  " << penetrationDepth << endl;
	out << "  Motion System:  " << motionSystem << endl;
	out << "  Deactivator Type:  " << deactivatorType << endl;
	out << "  Solver Deactivation:  " << solverDeactivation << endl;
	out << "  Quality Type:  " << qualityType << endl;
	out << "  Auto Remove Level:  " << autoRemoveLevel << endl;
	out << "  User Datas In Contact Point Properties?:  " << userDatasInContactPointProperties_ << endl;
	out << "  Force Collide Onto Ppu?:  " << forceCollideOntoPpu_ << endl;
	out << "  Num Constraints:  " << numConstraints << endl;
	array_output_count = 0;
	for (unsigned int i1 = 0; i1 < constraints.size(); i1++) {
		if ( !verbose && ( array_output_count > MAXARRAYDUMP ) ) {
			out << "<Data Truncated. Use verbose mode to see complete listing.>" << endl;
			break;
		};
		if ( !verbose && ( array_output_count > MAXARRAYDUMP ) ) {
			break;
		};
		out << "    Constraints[" << i1 << "]:  " << constraints[i1] << endl;
		array_output_count++;
	};
	out << "  Unknown Int 9:  " << unknownInt9 << endl;
	return out.str();

	//--BEGIN POST-STRING CUSTOM CODE--//
	//--END CUSTOM CODE--//
}

void bhkRigidBody::FixLinks( const map<unsigned int,NiObjectRef> & objects, list<unsigned int> & link_stack, const NifInfo & info ) {
	//--BEGIN PRE-FIXLINKS CUSTOM CODE--//
	//--END CUSTOM CODE--//

	bhkEntity::FixLinks( objects, link_stack, info );
	for (unsigned int i1 = 0; i1 < constraints.size(); i1++) {
		constraints[i1] = FixLink<bhkConstraint>( objects, link_stack, info );
	};

	//--BEGIN POST-FIXLINKS CUSTOM CODE--//
	//--END CUSTOM CODE--//
}

std::list<NiObjectRef> bhkRigidBody::GetRefs() const {
	list<Ref<NiObject> > refs;
	refs = bhkEntity::GetRefs();
	for (unsigned int i1 = 0; i1 < constraints.size(); i1++) {
		if ( constraints[i1] != NULL )
			refs.push_back(StaticCast<NiObject>(constraints[i1]));
	};
	return refs;
}

//--BEGIN MISC CUSTOM CODE--//

OblivionLayer bhkRigidBody::GetLayerCopy() const {
	return layerCopy;
}

void bhkRigidBody::SetLayerCopy( OblivionLayer value ) {
	layerCopy = value;
}

Vector4 bhkRigidBody::GetTranslation() const {
	return translation;
}

void bhkRigidBody::SetTranslation( const Vector4 & value ) {
	translation = value;
}

QuaternionXYZW bhkRigidBody::GetRotation() const {
	return rotation;
}

void bhkRigidBody::SetRotation( const QuaternionXYZW & value ) {
	rotation = value;
}

Vector4 bhkRigidBody::GetLinearVelocity() const {
	return linearVelocity;
}

void bhkRigidBody::SetLinearVelocity( const Vector4 & value ) {
	linearVelocity = value;
}

Vector4 bhkRigidBody::GetAngularVelocity() const {
	return angularVelocity;
}

void bhkRigidBody::SetAngularVelocity( const Vector4 & value ) {
	angularVelocity = value;
}

array<12,float>  bhkRigidBody::GetInertia() const {
	array<12, float> result;
	result[0] = inertia.m11;
	result[1] = inertia.m12;
	result[2] = inertia.m13;
	result[3] = inertia.m14;
	result[4] = inertia.m21;
	result[5] = inertia.m22;
	result[6] = inertia.m23;
	result[7] = inertia.m24;
	result[8] = inertia.m31;
	result[9] = inertia.m32;
	result[10] = inertia.m33;
	result[11] = inertia.m34;
	return result;
}

void bhkRigidBody::SetInertia( const array<12,float>&  value ) {
	inertia.m11 = value[0];
	inertia.m12 = value[1];
	inertia.m13 = value[2];
	inertia.m14 = value[3];
	inertia.m21 = value[4];
	inertia.m22 = value[5];
	inertia.m23 = value[6];
	inertia.m24 = value[7];
	inertia.m31 = value[8];
	inertia.m32 = value[9];
	inertia.m33 = value[10];
	inertia.m34 = value[11];
}

Vector4 bhkRigidBody::GetCenter() const {
	return center;
}

void bhkRigidBody::SetCenter( const Vector4 & value ) {
	center = value;
}

float bhkRigidBody::GetMass() const {
	return mass;
}

void bhkRigidBody::SetMass( float value ) {
	mass = value;
}

float bhkRigidBody::GetLinearDamping() const {
	return linearDamping;
}

void bhkRigidBody::SetLinearDamping( float value ) {
	linearDamping = value;
}

float bhkRigidBody::GetAngularDamping() const {
	return angularDamping;
}

void bhkRigidBody::SetAngularDamping( float value ) {
	angularDamping = value;
}

float bhkRigidBody::GetFriction() const {
	return friction;
}

void bhkRigidBody::SetFriction( float value ) {
	friction = value;
}

float bhkRigidBody::GetRestitution() const {
	return restitution;
}

void bhkRigidBody::SetRestitution( float value ) {
	restitution = value;
}

float bhkRigidBody::GetMaxLinearVelocity() const {
	return maxLinearVelocity;
}

void bhkRigidBody::SetMaxLinearVelocity( float value ) {
	maxLinearVelocity = value;
}

float bhkRigidBody::GetMaxAngularVelocity() const {
	return maxAngularVelocity;
}

void bhkRigidBody::SetMaxAngularVelocity( float value ) {
	maxAngularVelocity = value;
}

float bhkRigidBody::GetPenetrationDepth() const {
	return penetrationDepth;
}

void bhkRigidBody::SetPenetrationDepth( float value ) {
	penetrationDepth = value;
}

MotionSystem bhkRigidBody::GetMotionSystem() const {
	return motionSystem;
}

void bhkRigidBody::SetMotionSystem( MotionSystem value ) {
	motionSystem = value;
}

MotionQuality bhkRigidBody::GetQualityType() const {
	return qualityType;
}

void bhkRigidBody::SetQualityType( MotionQuality value ) {
	qualityType = value;
}

DeactivatorType bhkRigidBody::GetDeactivatorType() const {
	return deactivatorType;
}

void bhkRigidBody::SetDeactivatorType( const DeactivatorType & value ) {
	deactivatorType = value;
}

SolverDeactivation bhkRigidBody::GetSolverDeactivation() const {
	return solverDeactivation;
}

void bhkRigidBody::SetSolverDeactivation( const SolverDeactivation & value ) {
	solverDeactivation = value;
}

//--END CUSTOM CODE--//
